org.apache.xalan.xsltc.dom

## Class SimpleResultTreeImpl

- java.lang.Object
- - org.apache.xml.serializer.EmptySerializer
  - - org.apache.xalan.xsltc.dom.SimpleResultTreeImpl

- All Implemented Interfaces:
    DOM, DTM, DOMSerializer, ExtendedContentHandler, ExtendedLexicalHandler, SerializationHandler, Serializer, ContentHandler, DTDHandler, ErrorHandler, DeclHandler, LexicalHandler
  Direct Known Subclasses:
    AdaptiveResultTreeImpl

      public class SimpleResultTreeImpl
      extends EmptySerializer
      implements DOM, DTM

  This class represents a light-weight DOM model for simple result tree fragment(RTF). A simple RTF is an RTF that has only one Text node. The Text node can be produced by a combination of Text, xsl:value-of and xsl:number instructions. It can also be produced by a control structure (xsl:if or xsl:choose) whose body is pure Text.

  A SimpleResultTreeImpl has only two nodes, i.e. the ROOT node and its Text child. All DOM interfaces are overridden with this in mind. For example, the getStringValue() interface returns the value of the Text node. This class receives the character data from the characters() interface.

  This class implements DOM and SerializationHandler. It also implements the DTM interface for support in MultiDOM. The nested iterators (SimpleIterator and SingletonIterator) are used to support the nodeset() extension function.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `SimpleResultTreeImpl.SimpleIterator` The SimpleIterator is designed to support the nodeset() extension function.
    `class` | `SimpleResultTreeImpl.SingletonIterator` The SingletonIterator is used for the self axis.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `NUMBER_OF_NODES`
    `static int` | `RTF_ROOT`
    `static int` | `RTF_TEXT`

    - ### Fields inherited from interface org.apache.xalan.xsltc.DOM

      `ADAPTIVE_RTF, FIRST_TYPE, NO_TYPE, NULL, RETURN_CURRENT, RETURN_PARENT, SIMPLE_RTF, TREE_RTF`

    - ### Fields inherited from interface org.apache.xml.dtm.DTM

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NAMESPACE_NODE, NOTATION_NODE, NTYPES, NULL, PROCESSING_INSTRUCTION_NODE, ROOT_NODE, TEXT_NODE`

    - ### Fields inherited from interface org.apache.xml.serializer.ExtendedContentHandler

      `HTML_ATTREMPTY, HTML_ATTRURL, NO_BAD_CHARS`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SimpleResultTreeImpl(XSLTCDTMManager dtmManager, int documentID)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendChild(int newChild, boolean clone, boolean cloneDepth)` Append a child to "the end of the document".
    `void` | `appendTextChild(java.lang.String str)` Append a text node child that will be constructed from a string, to the end of the document.
    `void` | `characters(char[] ch, int offset, int length)` Receive notification of character data.
    `void` | `characters(int node, SerializationHandler handler)` Dispatch the character content of a node to an output handler.
    `void` | `characters(java.lang.String str)` This method is used to notify of a character event, but passing the data as a character String rather than the standard character array.
    `void` | `copy(DTMAxisIterator nodes, SerializationHandler handler)`
    `void` | `copy(int node, SerializationHandler handler)`
    `void` | `dispatchCharactersEvents(int nodeHandle, ContentHandler ch, boolean normalize)` Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `void` | `dispatchToEvents(int nodeHandle, ContentHandler ch)` Directly create SAX parser events representing the XML content of a DTM subtree.
    `void` | `documentRegistration()` As the DTM is registered with the DTMManager, this method will be called.
    `void` | `documentRelease()` As documents are released from the DTMManager, the DTM implementation will be notified of the event.
    `void` | `endDocument()` Receive notification of the end of a document.
    `int` | `getAttributeNode(int gType, int element)`
    `int` | `getAttributeNode(int elementHandle, java.lang.String namespaceURI, java.lang.String name)` Retrieves an attribute node by local name and namespace URI %TBD% Note that we currently have no way to support the DOM's old getAttribute() call, which accesses only the qname.
    `DTMAxisIterator` | `getAxisIterator(int axis)` This is a shortcut to the iterators that implement XPath axes.
    `DTMAxisTraverser` | `getAxisTraverser(int axis)` This returns a stateless "traverser", that can navigate over an XPath axis, though not in document order.
    `DTMAxisIterator` | `getChildren(int node)`
    `ContentHandler` | `getContentHandler()` Return this DTM's content handler, if it has one.
    `DeclHandler` | `getDeclHandler()` Return this DTM's DeclHandler, if it has one.
    `int` | `getDocument()` Given a DTM which contains only a single document, find the Node Handle of the Document node.
    `boolean` | `getDocumentAllDeclarationsProcessed()` Return an indication of whether the processor has read the complete DTD.
    `java.lang.String` | `getDocumentBaseURI()` Return the base URI of the document entity.
    `java.lang.String` | `getDocumentEncoding(int nodeHandle)` Return the name of the character encoding scheme in which the document entity is expressed.
    `int` | `getDocumentRoot(int nodeHandle)` Given a node handle, find the owning document node.
    `java.lang.String` | `getDocumentStandalone(int nodeHandle)` Return an indication of the standalone status of the document, either "yes" or "no".
    `java.lang.String` | `getDocumentSystemIdentifier(int nodeHandle)` Return the system identifier of the document entity.
    `java.lang.String` | `getDocumentTypeDeclarationPublicIdentifier()` Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML].
    `java.lang.String` | `getDocumentTypeDeclarationSystemIdentifier()` A document type declaration information item has the following properties: 1.
    `java.lang.String` | `getDocumentURI(int node)`
    `java.lang.String` | `getDocumentVersion(int documentHandle)` Return a string representing the XML version of the document.
    `DTDHandler` | `getDTDHandler()` Return this DTM's DTDHandler, if it has one.
    `DTMManagerDefault` | `getDTMManager()`
    `int` | `getElementById(java.lang.String elementId)` Returns the `Element` whose `ID` is given by `elementId`.
    `Hashtable` | `getElementsWithIDs()`
    `EntityResolver` | `getEntityResolver()` Return this DTM's EntityResolver, if it has one.
    `ErrorHandler` | `getErrorHandler()` Return this DTM's ErrorHandler, if it has one.
    `int` | `getExpandedTypeID(int nodeHandle)` Given a node handle, return an ID that represents the node's expanded name.
    `int` | `getExpandedTypeID(java.lang.String namespace, java.lang.String localName, int type)` Given an expanded name, return an ID.
    `int` | `getFirstAttribute(int nodeHandle)` Given a node handle, get the index of the node's first attribute.
    `int` | `getFirstChild(int nodeHandle)` Given a node handle, get the handle of the node's first child.
    `int` | `getFirstNamespaceNode(int nodeHandle, boolean inScope)` Given a node handle, get the index of the node's first namespace node.
    `DTMAxisIterator` | `getIterator()` returns singleton iterator containg the document root
    `java.lang.String` | `getLanguage(int node)`
    `int` | `getLastChild(int nodeHandle)` Given a node handle, get the handle of the node's last child.
    `short` | `getLevel(int nodeHandle)` Get the depth level of this node in the tree (equals 1 for a parentless node).
    `LexicalHandler` | `getLexicalHandler()` Return this DTM's lexical handler, if it has one.
    `java.lang.String` | `getLocalName(int nodeHandle)` Given a node handle, return its DOM-style localname.
    `java.lang.String` | `getLocalNameFromExpandedNameID(int ExpandedNameID)` Given an expanded-name ID, return the local name part.
    `DTMAxisIterator` | `getNamespaceAxisIterator(int axis, int ns)`
    `java.lang.String` | `getNamespaceFromExpandedNameID(int ExpandedNameID)` Given an expanded-name ID, return the namespace URI part.
    `java.lang.String` | `getNamespaceName(int node)`
    `int` | `getNamespaceType(int node)`
    `java.lang.String` | `getNamespaceURI(int nodeHandle)` Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)
    `int` | `getNextAttribute(int nodeHandle)` Given a node handle, advance to the next attribute.
    `int` | `getNextNamespaceNode(int baseHandle, int namespaceHandle, boolean inScope)` Given a namespace handle, advance to the next namespace in the same scope (local or local-plus-inherited, as selected by getFirstNamespaceNode)
    `int` | `getNextSibling(int nodeHandle)` Given a node handle, advance to its next sibling.
    `Node` | `getNode(int nodeHandle)` Return an DOM node for the given node.
    `int` | `getNodeHandle(int nodeId)` Return the node handle from a node identity.
    `int` | `getNodeIdent(int nodehandle)` Return the node identity from a node handle.
    `java.lang.String` | `getNodeName(int node)` Given a node handle, return its DOM-style node name.
    `java.lang.String` | `getNodeNameX(int node)` Given a node handle, return the XPath node name.
    `short` | `getNodeType(int nodeHandle)` Given a node handle, return its DOM-style node type.
    `java.lang.String` | `getNodeValue(int nodeHandle)` Given a node handle, return its node value.
    `DTMAxisIterator` | `getNodeValueIterator(DTMAxisIterator iter, int returnType, java.lang.String value, boolean op)`
    `int` | `getNSType(int node)`
    `DTMAxisIterator` | `getNthDescendant(int node, int n, boolean includeself)`
    `SerializationHandler` | `getOutputDomBuilder()`
    `int` | `getOwnerDocument(int nodeHandle)` Given a node handle, find the owning document node.
    `int` | `getParent(int nodeHandle)` Given a node handle, find its parent node.
    `java.lang.String` | `getPrefix(int nodeHandle)` Given a namespace handle, return the prefix that the namespace decl is mapping.
    `int` | `getPreviousSibling(int nodeHandle)` Given a node handle, find its preceeding sibling.
    `DOM` | `getResultTreeFrag(int initialSize, int rtfType)`
    `DOM` | `getResultTreeFrag(int initialSize, int rtfType, boolean addToManager)`
    `int` | `getSize()`
    `SourceLocator` | `getSourceLocatorFor(int node)` Get the location of a node in the source document.
    `java.lang.String` | `getStringValue()`
    `XMLString` | `getStringValue(int nodeHandle)` Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `char[]` | `getStringValueChunk(int nodeHandle, int chunkIndex, int[] startAndLen)` Get a character array chunk in the string-value of a node.
    `int` | `getStringValueChunkCount(int nodeHandle)` Get number of character array chunks in the string-value of a node.
    `java.lang.String` | `getStringValueX(int nodeHandle)`
    `DTMAxisIterator` | `getTypedAxisIterator(int axis, int type)` Get an iterator that can navigate over an XPath Axis, predicated by the extended type ID.
    `DTMAxisIterator` | `getTypedChildren(int type)`
    `java.lang.String` | `getUnparsedEntityURI(java.lang.String name)` The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]).
    `boolean` | `hasChildNodes(int nodeHandle)` Given a node handle, test if it has child nodes.
    `boolean` | `isAttribute(int node)`
    `boolean` | `isAttributeSpecified(int attributeHandle)` 5.
    `boolean` | `isCharacterElementContentWhitespace(int nodeHandle)` 2.
    `boolean` | `isDocumentAllDeclarationsProcessed(int documentHandle)` 10.
    `boolean` | `isElement(int node)`
    `boolean` | `isNodeAfter(int firstNodeHandle, int secondNodeHandle)` Figure out whether nodeHandle2 should be considered as being later in the document than nodeHandle1, in Document Order as defined by the XPath model.
    `boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Tests whether DTM DOM implementation implements a specific feature and that feature is supported by this node.
    `boolean` | `lessThan(int node1, int node2)`
    `java.lang.String` | `lookupNamespace(int node, java.lang.String prefix)`
    `Node` | `makeNode(DTMAxisIterator iter)`
    `Node` | `makeNode(int index)`
    `NodeList` | `makeNodeList(DTMAxisIterator iter)`
    `NodeList` | `makeNodeList(int index)`
    `void` | `migrateTo(DTMManager manager)` Migrate a DTM built with an old DTMManager to a new DTMManager.
    `boolean` | `needsTwoThreads()`
    `DTMAxisIterator` | `orderNodes(DTMAxisIterator source, int node)`
    `void` | `setDocumentBaseURI(java.lang.String baseURI)` Set the base URI of the document entity.
    `boolean` | `setEscaping(boolean escape)` Turns special character escaping on/off.
    `void` | `setFeature(java.lang.String featureId, boolean state)` The DTM interfaces are not used in this class.
    `void` | `setFilter(StripFilter filter)`
    `void` | `setProperty(java.lang.String property, java.lang.Object value)` Set a run time property for this DTM instance.
    `void` | `setupMapping(java.lang.String[] names, java.lang.String[] uris, int[] types, java.lang.String[] namespaces)`
    `java.lang.String` | `shallowCopy(int node, SerializationHandler handler)`
    `void` | `startDocument()` We only need to override the endDocument, characters, and setEscaping interfaces.
    `boolean` | `supportsPreStripping()` Return true if the xsl:strip-space or xsl:preserve-space was processed during construction of the document contained in this DTM.

    - ### Methods inherited from class org.apache.xml.serializer.EmptySerializer

      `addAttribute, addAttribute, addAttribute, addAttributes, addUniqueAttribute, addXSLAttribute, asContentHandler, asDOM3Serializer, asDOMSerializer, attributeDecl, characters, close, comment, comment, elementDecl, endCDATA, endDTD, endElement, endElement, endEntity, endPrefixMapping, entityReference, error, externalEntityDecl, fatalError, flushPending, getDoctypePublic, getDoctypeSystem, getEncoding, getIndent, getIndentAmount, getMediaType, getNamespaceMappings, getNamespaceURI, getNamespaceURIFromPrefix, getOmitXMLDeclaration, getOutputFormat, getOutputProperty, getOutputPropertyDefault, getOutputStream, getPrefix, getStandalone, getTransformer, getVersion, getWriter, ignorableWhitespace, internalEntityDecl, namespaceAfterStartElement, notationDecl, processingInstruction, reset, serialize, setCdataSectionElements, setCdataSectionElements, setContentHandler, setDoctype, setDoctypePublic, setDoctypeSystem, setDocumentLocator, setDTDEntityExpansion, setEncoding, setIndent, setIndentAmount, setMediaType, setNamespaceMappings, setOmitXMLDeclaration, setOutputFormat, setOutputProperty, setOutputPropertyDefault, setOutputStream, setSourceLocator, setStandalone, setTransformer, setVersion, setWriter, skippedEntity, startCDATA, startDTD, startElement, startElement, startElement, startEntity, startPrefixMapping, startPrefixMapping, unparsedEntityDecl, warning`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### RTF_ROOT

          public static final int RTF_ROOT

      See Also:
        Constant Field Values

    - #### RTF_TEXT

          public static final int RTF_TEXT

      See Also:
        Constant Field Values

    - #### NUMBER_OF_NODES

          public static final int NUMBER_OF_NODES

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### SimpleResultTreeImpl

          public SimpleResultTreeImpl(XSLTCDTMManager dtmManager,
                              int documentID)

  - ### Method Detail

    - #### getDTMManager

          public DTMManagerDefault getDTMManager()

    - #### getDocument

          public int getDocument()

      Description copied from interface: `DTM`
      Given a DTM which contains only a single document, find the Node Handle of the Document node. Note that if the DTM is configured so it can contain multiple documents, this call will return the Document currently under construction -- but may return null if it's between documents. Generally, you should use getOwnerDocument(nodeHandle) or getDocumentRoot(nodeHandle) instead.
      Specified by:
        `getDocument` in interface `DOM`
      Specified by:
        `getDocument` in interface `DTM`
      Returns:
        int Node handle of document, or DTM.NULL if a shared DTM can not tell us which Document is currently active.

    - #### getStringValue

          public java.lang.String getStringValue()

      Specified by:
        `getStringValue` in interface `DOM`

    - #### getIterator

          public DTMAxisIterator getIterator()

      Description copied from interface: `DOM`
      returns singleton iterator containg the document root
      Specified by:
        `getIterator` in interface `DOM`

    - #### getChildren

          public DTMAxisIterator getChildren(int node)

      Specified by:
        `getChildren` in interface `DOM`

    - #### getTypedChildren

          public DTMAxisIterator getTypedChildren(int type)

      Specified by:
        `getTypedChildren` in interface `DOM`

    - #### getAxisIterator

          public DTMAxisIterator getAxisIterator(int axis)

      Description copied from interface: `DTM`
      This is a shortcut to the iterators that implement XPath axes. Returns a bare-bones iterator that must be initialized with a start node (using iterator.setStartNode()).
      Specified by:
        `getAxisIterator` in interface `DOM`
      Specified by:
        `getAxisIterator` in interface `DTM`
      Parameters:
        `axis` - One of Axes.ANCESTORORSELF, etc.
      Returns:
        A DTMAxisIterator, or null if the givin axis isn't supported.

    - #### getTypedAxisIterator

          public DTMAxisIterator getTypedAxisIterator(int axis,
                                             int type)

      Description copied from interface: `DTM`
      Get an iterator that can navigate over an XPath Axis, predicated by the extended type ID.
      Specified by:
        `getTypedAxisIterator` in interface `DOM`
      Specified by:
        `getTypedAxisIterator` in interface `DTM`
        `type` - An extended type ID.
      Returns:
        A DTMAxisIterator, or null if the givin axis isn't supported.

    - #### getNthDescendant

          public DTMAxisIterator getNthDescendant(int node,
                                         int n,
                                         boolean includeself)

      Specified by:
        `getNthDescendant` in interface `DOM`

    - #### getNamespaceAxisIterator

          public DTMAxisIterator getNamespaceAxisIterator(int axis,
                                                 int ns)

      Specified by:
        `getNamespaceAxisIterator` in interface `DOM`

    - #### getNodeValueIterator

          public DTMAxisIterator getNodeValueIterator(DTMAxisIterator iter,
                                             int returnType,
                                             java.lang.String value,
                                             boolean op)

      Specified by:
        `getNodeValueIterator` in interface `DOM`

    - #### orderNodes

          public DTMAxisIterator orderNodes(DTMAxisIterator source,
                                   int node)

      Specified by:
        `orderNodes` in interface `DOM`

    - #### getNodeName

          public java.lang.String getNodeName(int node)

      Description copied from interface: `DTM`
      Given a node handle, return its DOM-style node name. This will include names such as #text or #document.
      Specified by:
        `getNodeName` in interface `DOM`
      Specified by:
        `getNodeName` in interface `DTM`
      Parameters:
        `node` - the id of the node.
      Returns:
        String Name of this node, which may be an empty string. %REVIEW% Document when empty string is possible...

    - #### getNodeNameX

          public java.lang.String getNodeNameX(int node)

      Description copied from interface: `DTM`
      Given a node handle, return the XPath node name. This should be the name as described by the XPath data model, NOT the DOM-style name.
      Specified by:
        `getNodeNameX` in interface `DOM`
      Specified by:
        `getNodeNameX` in interface `DTM`
      Parameters:
        `node` - the id of the node.
      Returns:
        String Name of this node.

    - #### getNamespaceName

          public java.lang.String getNamespaceName(int node)

      Specified by:
        `getNamespaceName` in interface `DOM`

    - #### getExpandedTypeID

          public int getExpandedTypeID(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, return an ID that represents the node's expanded name.
      Specified by:
        `getExpandedTypeID` in interface `DOM`
      Specified by:
        `getExpandedTypeID` in interface `DTM`
      Parameters:
        `nodeHandle` - The handle to the node in question.
      Returns:
        the expanded-name id of the node.

    - #### getNamespaceType

          public int getNamespaceType(int node)

      Specified by:
        `getNamespaceType` in interface `DOM`

    - #### getParent

          public int getParent(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, find its parent node.
      Specified by:
        `getParent` in interface `DOM`
      Specified by:
        `getParent` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of parent, or DTM.NULL to indicate none exists.

    - #### getAttributeNode

          public int getAttributeNode(int gType,
                             int element)

      Specified by:
        `getAttributeNode` in interface `DOM`

    - #### getStringValueX

          public java.lang.String getStringValueX(int nodeHandle)

      Specified by:
        `getStringValueX` in interface `DOM`

    - #### copy

          public void copy(int node,
                  SerializationHandler handler)
                    throws TransletException

      Specified by:
        `copy` in interface `DOM`
      Throws:
        `TransletException`

    - #### copy

          public void copy(DTMAxisIterator nodes,
                  SerializationHandler handler)
                    throws TransletException

      Specified by:
        `copy` in interface `DOM`
      Throws:
        `TransletException`

    - #### shallowCopy

          public java.lang.String shallowCopy(int node,
                                     SerializationHandler handler)
                                       throws TransletException

      Specified by:
        `shallowCopy` in interface `DOM`
      Throws:
        `TransletException`

    - #### lessThan

          public boolean lessThan(int node1,
                         int node2)

      Specified by:
        `lessThan` in interface `DOM`

    - #### characters

          public void characters(int node,
                        SerializationHandler handler)
                          throws TransletException

      Dispatch the character content of a node to an output handler. The escape setting should be taken care of when outputting to a handler.
      Specified by:
        `characters` in interface `DOM`
      Throws:
        `TransletException`

    - #### makeNode

          public Node makeNode(int index)

      Specified by:
        `makeNode` in interface `DOM`

    - #### makeNode

          public Node makeNode(DTMAxisIterator iter)

      Specified by:
        `makeNode` in interface `DOM`

    - #### makeNodeList

          public NodeList makeNodeList(int index)

      Specified by:
        `makeNodeList` in interface `DOM`

    - #### makeNodeList

          public NodeList makeNodeList(DTMAxisIterator iter)

      Specified by:
        `makeNodeList` in interface `DOM`

    - #### getLanguage

          public java.lang.String getLanguage(int node)

      Specified by:
        `getLanguage` in interface `DOM`

    - #### getSize

          public int getSize()

      Specified by:
        `getSize` in interface `DOM`

    - #### getDocumentURI

          public java.lang.String getDocumentURI(int node)

      Specified by:
        `getDocumentURI` in interface `DOM`

    - #### setFilter

          public void setFilter(StripFilter filter)

      Specified by:
        `setFilter` in interface `DOM`

    - #### setupMapping

          public void setupMapping(java.lang.String[] names,
                          java.lang.String[] uris,
                          int[] types,
                          java.lang.String[] namespaces)

      Specified by:
        `setupMapping` in interface `DOM`

    - #### isElement

          public boolean isElement(int node)

      Specified by:
        `isElement` in interface `DOM`

    - #### isAttribute

          public boolean isAttribute(int node)

      Specified by:
        `isAttribute` in interface `DOM`

    - #### lookupNamespace

          public java.lang.String lookupNamespace(int node,
                                         java.lang.String prefix)
                                           throws TransletException

      Specified by:
        `lookupNamespace` in interface `DOM`
      Throws:
        `TransletException`

    - #### getNodeIdent

          public int getNodeIdent(int nodehandle)

      Return the node identity from a node handle.
      Specified by:
        `getNodeIdent` in interface `DOM`

    - #### getNodeHandle

          public int getNodeHandle(int nodeId)

      Return the node handle from a node identity.
      Specified by:
        `getNodeHandle` in interface `DOM`

    - #### getResultTreeFrag

          public DOM getResultTreeFrag(int initialSize,
                              int rtfType)

      Specified by:
        `getResultTreeFrag` in interface `DOM`

    - #### getResultTreeFrag

          public DOM getResultTreeFrag(int initialSize,
                              int rtfType,
                              boolean addToManager)

      Specified by:
        `getResultTreeFrag` in interface `DOM`

    - #### getOutputDomBuilder

          public SerializationHandler getOutputDomBuilder()

      Specified by:
        `getOutputDomBuilder` in interface `DOM`

    - #### getNSType

          public int getNSType(int node)

      Specified by:
        `getNSType` in interface `DOM`

    - #### getUnparsedEntityURI

          public java.lang.String getUnparsedEntityURI(java.lang.String name)

      Description copied from interface: `DTM`
      The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]). It returns the empty string if there is no such entity.

      XML processors may choose to use the System Identifier (if one is provided) to resolve the entity, rather than the URI in the Public Identifier. The details are dependent on the processor, and we would have to support some form of plug-in resolver to handle this properly. Currently, we simply return the System Identifier if present, and hope that it a usable URI or that our caller can map it to one. %REVIEW% Resolve Public Identifiers... or consider changing function name.

      If we find a relative URI reference, XML expects it to be resolved in terms of the base URI of the document. The DOM doesn't do that for us, and it isn't entirely clear whether that should be done here; currently that's pushed up to a higher level of our application. (Note that DOM Level 1 didn't store the document's base URI.) %REVIEW% Consider resolving Relative URIs.

      (The DOM's statement that "An XML processor may choose to completely expand entities before the structure model is passed to the DOM" refers only to parsed entities, not unparsed, and hence doesn't affect this function.)

      Specified by:
        `getUnparsedEntityURI` in interface `DOM`
      Specified by:
        `getUnparsedEntityURI` in interface `DTM`
      Parameters:
        `name` - A string containing the Entity Name of the unparsed entity.
      Returns:
        String containing the URI of the Unparsed Entity, or an empty string if no such entity exists.

    - #### getElementsWithIDs

          public Hashtable getElementsWithIDs()

      Specified by:
        `getElementsWithIDs` in interface `DOM`

    - #### startDocument

          public void startDocument()
                             throws SAXException

      We only need to override the endDocument, characters, and setEscaping interfaces. A simple RTF does not have element nodes. We do not need to touch startElement and endElement.
      Specified by:
        `startDocument` in interface `ContentHandler`
      Overrides:
        `startDocument` in class `EmptySerializer`
      Throws:
        `SAXException` - any SAX exception, possibly wrapping another exception
      See Also:
        `ContentHandler.startDocument()`

    - #### endDocument

          public void endDocument()
                           throws SAXException

      Description copied from interface: `ContentHandler`
      Receive notification of the end of a document.

      There is an apparent contradiction between the documentation for this method and the documentation for `ErrorHandler.fatalError(org.xml.sax.SAXParseException)`. Until this ambiguity is resolved in a future major release, clients should make no assumptions about whether endDocument() will or will not be invoked when the parser has reported a fatalError() or thrown an exception.

      The SAX parser will invoke this method only once, and it will be the last method invoked during the parse. The parser shall not invoke this method until it has either abandoned parsing (because of an unrecoverable error) or reached the end of input.

      Specified by:
        `endDocument` in interface `ContentHandler`
      Overrides:
        `endDocument` in class `EmptySerializer`
      Throws:
        `SAXException` - any SAX exception, possibly wrapping another exception
      See Also:
        `ContentHandler.endDocument()`

    - #### characters

          public void characters(java.lang.String str)
                          throws SAXException

      Description copied from interface: `ExtendedContentHandler`
      This method is used to notify of a character event, but passing the data as a character String rather than the standard character array.
      Specified by:
        `characters` in interface `ExtendedContentHandler`
      Overrides:
        `characters` in class `EmptySerializer`
      Parameters:
        `str` - the character data
      Throws:
        `SAXException`
      See Also:
        `ExtendedContentHandler.characters(java.lang.String)`

    - #### characters

          public void characters(char[] ch,
                        int offset,
                        int length)
                          throws SAXException

      Description copied from interface: `ContentHandler`
      Receive notification of character data.

      The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

      The application must not attempt to read from the array outside of the specified range.

      Individual characters may consist of more than one Java `char` value. There are two important cases where this happens, because characters can't be represented in just sixteen bits. In one case, characters are represented in a Surrogate Pair, using two special Unicode values. Such characters are in the so-called "Astral Planes", with a code point above U+FFFF. A second case involves composite characters, such as a base character combining with one or more accent characters.

      Your code should not assume that algorithms using `char`-at-a-time idioms will be working in character units; in some cases they will split characters. This is relevant wherever XML permits arbitrary characters, such as attribute values, processing instruction data, and comments as well as in data reported from this method. It's also generally relevant whenever Java code manipulates internationalized text; the issue isn't unique to XML.

      Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

      Specified by:
        `characters` in interface `ContentHandler`
      Overrides:
        `characters` in class `EmptySerializer`
      Parameters:
        `ch` - the characters from the XML document
        `offset` - the start position in the array
        `length` - the number of characters to read from the array
      Throws:
        `SAXException` - any SAX exception, possibly wrapping another exception
      See Also:
        `ContentHandler.characters(char[], int, int)`

    - #### setEscaping

          public boolean setEscaping(boolean escape)
                              throws SAXException

      Description copied from interface: `SerializationHandler`
      Turns special character escaping on/off. Note that characters will never, even if this option is set to 'true', be escaped within CDATA sections in output XML documents.
      Specified by:
        `setEscaping` in interface `SerializationHandler`
      Overrides:
        `setEscaping` in class `EmptySerializer`
      Parameters:
        `escape` - true if escaping is to be set on.
      Throws:
        `SAXException`
      See Also:
        `SerializationHandler.setEscaping(boolean)`

    - #### setFeature

          public void setFeature(java.lang.String featureId,
                        boolean state)

      The DTM interfaces are not used in this class. Implementing the DTM interface is a requirement from MultiDOM. If we have a better way of handling multiple documents, we can get rid of the DTM dependency. The following interfaces are just placeholders. The implementation does not have an impact because they will not be used.
      Specified by:
        `setFeature` in interface `DTM`
      Parameters:
        `featureId` - A feature URL.
        `state` - true if this feature should be on, false otherwise.

    - #### setProperty

          public void setProperty(java.lang.String property,
                         java.lang.Object value)

      Description copied from interface: `DTM`
      Set a run time property for this DTM instance.
      Specified by:
        `setProperty` in interface `DTM`
      Parameters:
        `property` - a `String` value
        `value` - an `Object` value

    - #### getAxisTraverser

          public DTMAxisTraverser getAxisTraverser(int axis)

      Description copied from interface: `DTM`
      This returns a stateless "traverser", that can navigate over an XPath axis, though not in document order.
      Specified by:
        `getAxisTraverser` in interface `DTM`
      Parameters:
        `axis` - One of Axes.ANCESTORORSELF, etc.
      Returns:
        A DTMAxisIterator, or null if the givin axis isn't supported.

    - #### hasChildNodes

          public boolean hasChildNodes(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, test if it has child nodes.

      %REVIEW% This is obviously useful at the DOM layer, where it would permit testing this without having to create a proxy node. It's less useful in the DTM API, where (dtm.getFirstChild(nodeHandle)!=DTM.NULL) is just as fast and almost as self-evident. But it's a convenience, and eases porting of DOM code to DTM.

      Specified by:
        `hasChildNodes` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int true if the given node has child nodes.

    - #### getFirstChild

          public int getFirstChild(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, get the handle of the node's first child.
      Specified by:
        `getFirstChild` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of first child, or DTM.NULL to indicate none exists.

    - #### getLastChild

          public int getLastChild(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, get the handle of the node's last child.
      Specified by:
        `getLastChild` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of last child, or DTM.NULL to indicate none exists.

    - #### getAttributeNode

          public int getAttributeNode(int elementHandle,
                             java.lang.String namespaceURI,
                             java.lang.String name)

      Description copied from interface: `DTM`
      Retrieves an attribute node by local name and namespace URI %TBD% Note that we currently have no way to support the DOM's old getAttribute() call, which accesses only the qname.
      Specified by:
        `getAttributeNode` in interface `DTM`
      Parameters:
        `elementHandle` - Handle of the node upon which to look up this attribute.
        `namespaceURI` - The namespace URI of the attribute to retrieve, or null.
        `name` - The local name of the attribute to retrieve.
      Returns:
        The attribute node handle with the specified name ( `nodeName`) or `DTM.NULL` if there is no such attribute.

    - #### getFirstAttribute

          public int getFirstAttribute(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, get the index of the node's first attribute.
      Specified by:
        `getFirstAttribute` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        Handle of first attribute, or DTM.NULL to indicate none exists.

    - #### getFirstNamespaceNode

          public int getFirstNamespaceNode(int nodeHandle,
                                  boolean inScope)

      Description copied from interface: `DTM`
      Given a node handle, get the index of the node's first namespace node.
      Specified by:
        `getFirstNamespaceNode` in interface `DTM`
      Parameters:
        `nodeHandle` - handle to node, which should probably be an element node, but need not be.
        `inScope` - true if all namespaces in scope should be returned, false if only the node's own namespace declarations should be returned.
      Returns:
        handle of first namespace, or DTM.NULL to indicate none exists.

    - #### getNextSibling

          public int getNextSibling(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, advance to its next sibling.
      Specified by:
        `getNextSibling` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of next sibling, or DTM.NULL to indicate none exists.

    - #### getPreviousSibling

          public int getPreviousSibling(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, find its preceeding sibling. WARNING: DTM implementations may be asymmetric; in some, this operation has been resolved by search, and is relatively expensive.
      Specified by:
        `getPreviousSibling` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node-number of the previous sib, or DTM.NULL to indicate none exists.

    - #### getNextAttribute

          public int getNextAttribute(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, advance to the next attribute. If an element, we advance to its first attribute; if an attr, we advance to the next attr of the same element.
      Specified by:
        `getNextAttribute` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of the resolved attr, or DTM.NULL to indicate none exists.

    - #### getNextNamespaceNode

          public int getNextNamespaceNode(int baseHandle,
                                 int namespaceHandle,
                                 boolean inScope)

      Description copied from interface: `DTM`
      Given a namespace handle, advance to the next namespace in the same scope (local or local-plus-inherited, as selected by getFirstNamespaceNode)
      Specified by:
        `getNextNamespaceNode` in interface `DTM`
      Parameters:
        `baseHandle` - handle to original node from where the first child was relative to (needed to return nodes in document order).
        `namespaceHandle` - handle to node which must be of type NAMESPACE_NODE. NEEDSDOC @param inScope
      Returns:
        handle of next namespace, or DTM.NULL to indicate none exists.

    - #### getOwnerDocument

          public int getOwnerDocument(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, find the owning document node. This version mimics the behavior of the DOM call by the same name.
      Specified by:
        `getOwnerDocument` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of owning document, or DTM.NULL if the node was a Document.
      See Also:
        `DTM.getDocumentRoot(int nodeHandle)`

    - #### getDocumentRoot

          public int getDocumentRoot(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, find the owning document node.
      Specified by:
        `getDocumentRoot` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of owning document, or the node itself if it was a Document. (Note difference from DOM, where getOwnerDocument returns null for the Document node.)
      See Also:
        `DTM.getOwnerDocument(int nodeHandle)`

    - #### getStringValue

          public XMLString getStringValue(int nodeHandle)

      Description copied from interface: `DTM`
      Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
      Specified by:
        `getStringValue` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A string object that represents the string-value of the given node.

    - #### getStringValueChunkCount

          public int getStringValueChunkCount(int nodeHandle)

      Description copied from interface: `DTM`
      Get number of character array chunks in the string-value of a node. (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Note that a single text node may have multiple text chunks.
      Specified by:
        `getStringValueChunkCount` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        number of character array chunks in the string-value of a node.

    - #### getStringValueChunk

          public char[] getStringValueChunk(int nodeHandle,
                                   int chunkIndex,
                                   int[] startAndLen)

      Description copied from interface: `DTM`
      Get a character array chunk in the string-value of a node. (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Note that a single text node may have multiple text chunks.
      Specified by:
        `getStringValueChunk` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `chunkIndex` - Which chunk to get.
        `startAndLen` - A two-integer array which, upon return, WILL BE FILLED with values representing the chunk's start position within the returned character buffer and the length of the chunk.
      Returns:
        The character array buffer within which the chunk occurs, setting startAndLen's contents as a side-effect.

    - #### getExpandedTypeID

          public int getExpandedTypeID(java.lang.String namespace,
                              java.lang.String localName,
                              int type)

      Description copied from interface: `DTM`
      Given an expanded name, return an ID. If the expanded-name does not exist in the internal tables, the entry will be created, and the ID will be returned. Any additional nodes that are created that have this expanded name will use this ID. NEEDSDOC @param namespace NEEDSDOC @param localName NEEDSDOC @param type
      Specified by:
        `getExpandedTypeID` in interface `DTM`
      Returns:
        the expanded-name id of the node.

    - #### getLocalNameFromExpandedNameID

          public java.lang.String getLocalNameFromExpandedNameID(int ExpandedNameID)

      Description copied from interface: `DTM`
      Given an expanded-name ID, return the local name part.
      Specified by:
        `getLocalNameFromExpandedNameID` in interface `DTM`
      Parameters:
        `ExpandedNameID` - an ID that represents an expanded-name.
      Returns:
        String Local name of this node.

    - #### getNamespaceFromExpandedNameID

          public java.lang.String getNamespaceFromExpandedNameID(int ExpandedNameID)

      Description copied from interface: `DTM`
      Given an expanded-name ID, return the namespace URI part.
      Specified by:
        `getNamespaceFromExpandedNameID` in interface `DTM`
      Parameters:
        `ExpandedNameID` - an ID that represents an expanded-name.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getLocalName

          public java.lang.String getLocalName(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, return its DOM-style localname. (As defined in Namespaces, this is the portion of the name after the prefix, if present, or the whole node name if no prefix exists)
      Specified by:
        `getLocalName` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Local name of this node.

    - #### getPrefix

          public java.lang.String getPrefix(int nodeHandle)

      Description copied from interface: `DTM`
      Given a namespace handle, return the prefix that the namespace decl is mapping. Given a node handle, return the prefix used to map to the namespace. (As defined in Namespaces, this is the portion of the name before any colon character).

      %REVIEW% Are you sure you want "" for no prefix?

      Specified by:
        `getPrefix` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String prefix of this node's name, or "" if no explicit namespace prefix was given.

    - #### getNamespaceURI

          public java.lang.String getNamespaceURI(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)
      Specified by:
        `getNamespaceURI` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getNodeValue

          public java.lang.String getNodeValue(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, return its node value. This is mostly as defined by the DOM, but may ignore some conveniences.

      Specified by:
        `getNodeValue` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        String Value of this node, or null if not meaningful for this node type.

    - #### getNodeType

          public short getNodeType(int nodeHandle)

      Description copied from interface: `DTM`
      Given a node handle, return its DOM-style node type.

      %REVIEW% Generally, returning short is false economy. Return int?

      Specified by:
        `getNodeType` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        int Node type, as per the DOM's Node._NODE constants.

    - #### getLevel

          public short getLevel(int nodeHandle)

      Description copied from interface: `DTM`
      Get the depth level of this node in the tree (equals 1 for a parentless node).
      Specified by:
        `getLevel` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        the number of ancestors, plus one

    - #### isSupported

          public boolean isSupported(java.lang.String feature,
                            java.lang.String version)

      Description copied from interface: `DTM`
      Tests whether DTM DOM implementation implements a specific feature and that feature is supported by this node.
      Specified by:
        `isSupported` in interface `DTM`
      Parameters:
        `feature` - The name of the feature to test.
        `version` - This is the version number of the feature to test. If the version is not specified, supporting any version of the feature will cause the method to return `true`.
      Returns:
        Returns `true` if the specified feature is supported on this node, `false` otherwise.

    - #### getDocumentBaseURI

          public java.lang.String getDocumentBaseURI()

      Description copied from interface: `DTM`
      Return the base URI of the document entity. If it is not known (because the document was parsed from a socket connection or from standard input, for example), the value of this property is unknown.
      Specified by:
        `getDocumentBaseURI` in interface `DTM`
      Returns:
        the document base URI String object or null if unknown.

    - #### setDocumentBaseURI

          public void setDocumentBaseURI(java.lang.String baseURI)

      Description copied from interface: `DTM`
      Set the base URI of the document entity.
      Specified by:
        `setDocumentBaseURI` in interface `DTM`
      Parameters:
        `baseURI` - the document base URI String object or null if unknown.

    - #### getDocumentSystemIdentifier

          public java.lang.String getDocumentSystemIdentifier(int nodeHandle)

      Description copied from interface: `DTM`
      Return the system identifier of the document entity. If it is not known, the value of this property is null.
      Specified by:
        `getDocumentSystemIdentifier` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the system identifier String object or null if unknown.

    - #### getDocumentEncoding

          public java.lang.String getDocumentEncoding(int nodeHandle)

      Description copied from interface: `DTM`
      Return the name of the character encoding scheme in which the document entity is expressed.
      Specified by:
        `getDocumentEncoding` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the document encoding String object.

    - #### getDocumentStandalone

          public java.lang.String getDocumentStandalone(int nodeHandle)

      Description copied from interface: `DTM`
      Return an indication of the standalone status of the document, either "yes" or "no". This property is derived from the optional standalone document declaration in the XML declaration at the beginning of the document entity, and has no value if there is no standalone document declaration.
      Specified by:
        `getDocumentStandalone` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the document standalone String object, either "yes", "no", or null.

    - #### getDocumentVersion

          public java.lang.String getDocumentVersion(int documentHandle)

      Description copied from interface: `DTM`
      Return a string representing the XML version of the document. This property is derived from the XML declaration optionally present at the beginning of the document entity, and has no value if there is no XML declaration.
      Specified by:
        `getDocumentVersion` in interface `DTM`
      Parameters:
        `documentHandle` - the document handle
      Returns:
        the document version String object

    - #### getDocumentAllDeclarationsProcessed

          public boolean getDocumentAllDeclarationsProcessed()

      Description copied from interface: `DTM`
      Return an indication of whether the processor has read the complete DTD. Its value is a boolean. If it is false, then certain properties (indicated in their descriptions below) may be unknown. If it is true, those properties are never unknown.
      Specified by:
        `getDocumentAllDeclarationsProcessed` in interface `DTM`
      Returns:
        `true` if all declarations were processed; `false` otherwise.

    - #### getDocumentTypeDeclarationSystemIdentifier

          public java.lang.String getDocumentTypeDeclarationSystemIdentifier()

      Description copied from interface: `DTM`
      A document type declaration information item has the following properties: 1. [system identifier] The system identifier of the external subset, if it exists. Otherwise this property has no value.
      Specified by:
        `getDocumentTypeDeclarationSystemIdentifier` in interface `DTM`
      Returns:
        the system identifier String object, or null if there is none.

    - #### getDocumentTypeDeclarationPublicIdentifier

          public java.lang.String getDocumentTypeDeclarationPublicIdentifier()

      Description copied from interface: `DTM`
      Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML]. If there is no external subset or if it has no public identifier, this property has no value.
      Specified by:
        `getDocumentTypeDeclarationPublicIdentifier` in interface `DTM`
      Returns:
        the public identifier String object, or null if there is none.

    - #### getElementById

          public int getElementById(java.lang.String elementId)

      Description copied from interface: `DTM`
      Returns the `Element` whose `ID` is given by `elementId`. If no such element exists, returns `DTM.NULL`. Behavior is not defined if more than one element has this `ID`. Attributes (including those with the name "ID") are not of type ID unless so defined by DTD/Schema information available to the DTM implementation. Implementations that do not know whether attributes are of type ID or not are expected to return `DTM.NULL`.

      %REVIEW% Presumably IDs are still scoped to a single document, and this operation searches only within a single document, right? Wouldn't want collisions between DTMs in the same process.

      Specified by:
        `getElementById` in interface `DTM`
      Parameters:
        `elementId` - The unique `id` value for an element.
      Returns:
        The handle of the matching element.

    - #### supportsPreStripping

          public boolean supportsPreStripping()

      Description copied from interface: `DTM`
      Return true if the xsl:strip-space or xsl:preserve-space was processed during construction of the document contained in this DTM. NEEDSDOC ($objectName$) @return
      Specified by:
        `supportsPreStripping` in interface `DTM`

    - #### isNodeAfter

          public boolean isNodeAfter(int firstNodeHandle,
                            int secondNodeHandle)

      Description copied from interface: `DTM`
      Figure out whether nodeHandle2 should be considered as being later in the document than nodeHandle1, in Document Order as defined by the XPath model. This may not agree with the ordering defined by other XML applications.

      There are some cases where ordering isn't defined, and neither are the results of this function -- though we'll generally return true.

      %REVIEW% Make sure this does the right thing with attribute nodes!!!

      %REVIEW% Consider renaming for clarity. Perhaps isDocumentOrder(a,b)?

      Specified by:
        `isNodeAfter` in interface `DTM`
      Parameters:
        `firstNodeHandle` - DOM Node to perform position comparison on.
        `secondNodeHandle` - DOM Node to perform position comparison on.
      Returns:
        false if secondNode comes before firstNode, otherwise return true. You can think of this as `(firstNode.documentOrderPosition <= secondNode.documentOrderPosition)`.

    - #### isCharacterElementContentWhitespace

          public boolean isCharacterElementContentWhitespace(int nodeHandle)

      Description copied from interface: `DTM`
      2. [element content whitespace] A boolean indicating whether a text node represents white space appearing within element content (see [XML], 2.10 "White Space Handling"). Note that validating XML processors are required by XML 1.0 to provide this information... but that DOM Level 2 did not support it, since it depends on knowledge of the DTD which DOM2 could not guarantee would be available.

      If there is no declaration for the containing element, an XML processor must assume that the whitespace could be meaningful and return false. If no declaration has been read, but the [all declarations processed] property of the document information item is false (so there may be an unread declaration), then the value of this property is indeterminate for white space characters and should probably be reported as false. It is always false for text nodes that contain anything other than (or in addition to) white space.

      Note too that it always returns false for non-Text nodes.

      %REVIEW% Joe wants to rename this isWhitespaceInElementContent() for clarity

      Specified by:
        `isCharacterElementContentWhitespace` in interface `DTM`
      Parameters:
        `nodeHandle` - the node ID.
      Returns:
        `true` if the node definitely represents whitespace in element content; `false` otherwise.

    - #### isDocumentAllDeclarationsProcessed

          public boolean isDocumentAllDeclarationsProcessed(int documentHandle)

      Description copied from interface: `DTM`
      10. [all declarations processed] This property is not strictly speaking part of the infoset of the document. Rather it is an indication of whether the processor has read the complete DTD. Its value is a boolean. If it is false, then certain properties (indicated in their descriptions below) may be unknown. If it is true, those properties are never unknown.
      Specified by:
        `isDocumentAllDeclarationsProcessed` in interface `DTM`
      Parameters:
        `documentHandle` - A node handle that must identify a document.
      Returns:
        `true` if all declarations were processed; `false` otherwise.

    - #### isAttributeSpecified

          public boolean isAttributeSpecified(int attributeHandle)

      Description copied from interface: `DTM`
      5. [specified] A flag indicating whether this attribute was actually specified in the start-tag of its element, or was defaulted from the DTD (or schema).
      Specified by:
        `isAttributeSpecified` in interface `DTM`
      Parameters:
        `attributeHandle` - The attribute handle
      Returns:
        `true` if the attribute was specified; `false` if it was defaulted or the handle doesn't refer to an attribute node.

    - #### dispatchCharactersEvents

          public void dispatchCharactersEvents(int nodeHandle,
                                      ContentHandler ch,
                                      boolean normalize)
                                        throws SAXException

      Description copied from interface: `DTM`
      Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Multiple calls to the ContentHandler's characters methods may well occur for a single call to this method.
      Specified by:
        `dispatchCharactersEvents` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
        `normalize` - true if the content should be normalized according to the rules for the XPath normalize-space function.
      Throws:
        `SAXException`

    - #### dispatchToEvents

          public void dispatchToEvents(int nodeHandle,
                              ContentHandler ch)
                                throws SAXException

      Description copied from interface: `DTM`
      Directly create SAX parser events representing the XML content of a DTM subtree. This is a "serialize" operation.
      Specified by:
        `dispatchToEvents` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
      Throws:
        `SAXException`

    - #### getNode

          public Node getNode(int nodeHandle)

      Description copied from interface: `DTM`
      Return an DOM node for the given node.
      Specified by:
        `getNode` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A node representation of the DTM node.

    - #### needsTwoThreads

          public boolean needsTwoThreads()

      Specified by:
        `needsTwoThreads` in interface `DTM`
      Returns:
        true iff we're building this model incrementally (eg we're partnered with a CoroutineParser) and thus require that the transformation and the parse run simultaneously. Guidance to the DTMManager.

    - #### getContentHandler

          public ContentHandler getContentHandler()

      Description copied from interface: `DTM`
      Return this DTM's content handler, if it has one.
      Specified by:
        `getContentHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX events.

    - #### getLexicalHandler

          public LexicalHandler getLexicalHandler()

      Description copied from interface: `DTM`
      Return this DTM's lexical handler, if it has one. %REVIEW% Should this return null if constrution already done/begun?
      Specified by:
        `getLexicalHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to lexical SAX events.

    - #### getEntityResolver

          public EntityResolver getEntityResolver()

      Description copied from interface: `DTM`
      Return this DTM's EntityResolver, if it has one.
      Specified by:
        `getEntityResolver` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX entity ref events.

    - #### getDTDHandler

          public DTDHandler getDTDHandler()

      Description copied from interface: `DTM`
      Return this DTM's DTDHandler, if it has one.
      Specified by:
        `getDTDHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX dtd events.

    - #### getErrorHandler

          public ErrorHandler getErrorHandler()

      Description copied from interface: `DTM`
      Return this DTM's ErrorHandler, if it has one.
      Specified by:
        `getErrorHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX error events.

    - #### getDeclHandler

          public DeclHandler getDeclHandler()

      Description copied from interface: `DTM`
      Return this DTM's DeclHandler, if it has one.
      Specified by:
        `getDeclHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX Decl events.

    - #### appendChild

          public void appendChild(int newChild,
                         boolean clone,
                         boolean cloneDepth)

      Description copied from interface: `DTM`
      Append a child to "the end of the document". Please note that the node is always cloned in a base DTM, since our basic behavior is immutable so nodes can't be removed from their previous location.

      %REVIEW% DTM maintains an insertion cursor which performs a depth-first tree walk as nodes come in, and this operation is really equivalent to: insertionCursor.appendChild(document.importNode(newChild))) where the insert point is the last element that was appended (or the last one popped back to by an end-element operation).

      Specified by:
        `appendChild` in interface `DTM`
      Parameters:
        `newChild` - Must be a valid new node handle.
        `clone` - true if the child should be cloned into the document.
        `cloneDepth` - if the clone argument is true, specifies that the clone should include all it's children.

    - #### appendTextChild

          public void appendTextChild(java.lang.String str)

      Description copied from interface: `DTM`
      Append a text node child that will be constructed from a string, to the end of the document. Behavior is otherwise like appendChild().
      Specified by:
        `appendTextChild` in interface `DTM`
      Parameters:
        `str` - Non-null reference to a string.

    - #### getSourceLocatorFor

          public SourceLocator getSourceLocatorFor(int node)

      Description copied from interface: `DTM`
      Get the location of a node in the source document.
      Specified by:
        `getSourceLocatorFor` in interface `DTM`
      Parameters:
        `node` - an `int` value
      Returns:
        a `SourceLocator` value or null if no location is available

    - #### documentRegistration

          public void documentRegistration()

      Description copied from interface: `DTM`
      As the DTM is registered with the DTMManager, this method will be called. This will give the DTM implementation a chance to initialize any subsystems that are required to build the DTM
      Specified by:
        `documentRegistration` in interface `DTM`

    - #### documentRelease

          public void documentRelease()

      Description copied from interface: `DTM`
      As documents are released from the DTMManager, the DTM implementation will be notified of the event. This will allow the DTM implementation to shutdown any subsystem activity that may of been assoiated with the active DTM Implementation.
      Specified by:
        `documentRelease` in interface `DTM`

    - #### migrateTo

          public void migrateTo(DTMManager manager)

      Description copied from interface: `DTM`
      Migrate a DTM built with an old DTMManager to a new DTMManager. After the migration, the new DTMManager will treat the DTM as one that is built by itself. This is used to support DTM sharing between multiple transformations.
      Specified by:
        `migrateTo` in interface `DTM`
      Parameters:
        `manager` - the DTMManager

Copyright © 2014 Apache XML Project. All Rights Reserved.